From 685d68c0bf133e1c9d05c8a6a2a740f72b96ba56 Mon Sep 17 00:00:00 2001
From: Anton Rudnev <mibori@builder.office.etersoft.ru>
Date: Mon, 16 Feb 2009 18:10:41 +0300
Subject: [PATCH] ntdll: eterbug-1959: fix UNC-path processing in RtlSetCurrentDirectory_U

---
 dlls/ntdll/path.c |   16 ++++++++++++++--
 1 files changed, 14 insertions(+), 2 deletions(-)

diff --git a/dlls/ntdll/path.c b/dlls/ntdll/path.c
index 66d7b7a..e542558 100644
--- a/dlls/ntdll/path.c
+++ b/dlls/ntdll/path.c
@@ -995,8 +995,20 @@ NTSTATUS WINAPI RtlSetCurrentDirectory_U(const UNICODE_STRING* dir)
     /* append trailing \ if missing */
     size = newdir.Length / sizeof(WCHAR);
     ptr = newdir.Buffer;
-    ptr += 4;  /* skip \??\ prefix */
-    size -= 4;
+
+    /* eterbug 1959: if `\??\UNC\' prefix */
+    if(!strncmpW(ptr + strlenW(NTDosPrefixW), UncPfxW, strlenW(UncPfxW)))
+    {   /* skip `\??\UN' prefix */
+        ptr += strlenW(NTDosPrefixW) + strlenW(UncPfxW) - 2;
+        size -= strlenW(NTDosPrefixW) + strlenW(UncPfxW) - 2;
+        *ptr = '\\'; /* `C\' -> `\\' */
+    }
+    else
+    {   // skip \??\ prefix
+        ptr += strlenW(NTDosPrefixW);
+        size -= strlenW(NTDosPrefixW);
+    }
+
     if (size && ptr[size - 1] != '\\') ptr[size++] = '\\';
 
     memcpy( curdir->DosPath.Buffer, ptr, size * sizeof(WCHAR));
-- 
1.6.1.3.GIT

